#pragma once

#include <WinError.h>
#include "NPErrorCode.h"

#define	NPERRCODE	long

#include <atlstr.h>

inline CString GetErrorMsg(NPERRCODE nErrorCode)
{
	CString strMsg;
	LPVOID lpMsgBuf;
	if (!FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER | 
		FORMAT_MESSAGE_FROM_SYSTEM | 
		FORMAT_MESSAGE_IGNORE_INSERTS,
		NULL,
		nErrorCode,
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
		(LPTSTR) &lpMsgBuf,
		0,
		NULL ))
	{
		// Handle the error.
		return strMsg;
	}

	strMsg = LPCTSTR(lpMsgBuf);
	// Free the buffer.
	LocalFree( lpMsgBuf );

	return strMsg;
}

#define	MAKE_BASE_ERRORSTRING(x)	GetErrorMsg(x)
	